!---------------------------------------------------------------------
!     Copyright (C) GFD Dennou Club, 2004. All rights reserved.
!---------------------------------------------------------------------
                                                                 !=begin
!= Subroutine TurbulenceVelX
!
!   * Developer: SUGIYAMA Ko-ichiro (sugiyama@gfd-dennou.org)
!   * Version: $Id: turbulencevelx.f90,v 1.4 2005/02/18 06:49:29 odakker Exp $ 
!   * Tag Name: $Name:  $
!   * Change History: 
!
!== Overview 
!
!X αưǴȻɾ. 
!Ȥ˴ϢʤȤưĹ֥ƥåפɾ
!
!== Error Handling
!
!== Known Bugs
!
!== Note
!
!== Future Plans
!
                                                                 !=end


subroutine TurbulenceVelX(fs_VelX_n, sf_VelZ_n, ss_Km_n, fs_TurbVelX_n)
                                                                 !=begin  
  !== Dependency 
  use dc_trace, only: BeginSub, EndSub
  use gridset,  only: DimXMin, DimXMax, DimZMin, DimZMax, DelXZ
  use differentiate,  only: fs_dx_ss, ss_dx_fs, fs_dz_ff, ff_dx_sf, &
       &                    fs_dz_ff, ff_dz_fs, fs_dx_ss
  use average,        only: ff_avr_ss
  use arareprm, only: Cm
                                                                 !=end  
  !--- ۤηػ
  implicit none
                                                                 !=begin    
  !== Input 
  real(8), intent(in) :: fs_VelX_n(DimXMin:DimXMax, DimZMin:DimZMax) !® u
  real(8), intent(in) :: sf_VelZ_n(DimXMin:DimXMax, DimZMin:DimZMax) !® w
  real(8), intent(in) :: ss_Km_n(DimXMin:DimXMax, DimZMin:DimZMax)   !Ǵ
  
  !== Output
  real(8), intent(out) :: fs_TurbVelX_n(DimXMin:DimXMax, DimZMin:DimZMax) !ǴȻ
                                                                 !=end
  call BeginSub("TurbulenceVelX", &
&              fmt="%c",       &
&              c1="Calculate terbulent diffusion term for VelX (fs_TurbVelX).")


  !--- ® u ФȻ 
  fs_TurbVelX_n = &
       &   2.0d0 * fs_dx_ss( ss_Km_n * ss_dx_fs( fs_VelX_n ) ) &
       & + fs_dz_ff( ff_avr_ss( ss_Km_n ) * ff_dx_sf( sf_VelZ_n ) )  &
       & + fs_dz_ff( ff_avr_ss( ss_Km_n ) * ff_dz_fs( fs_VelX_n ) )  &
       & - 2.0d0 * fs_dx_ss( ( ss_Km_n ** 2.0d0 ) ) &
       &   / ( 3.0d0 * ( Cm ** 2.0d0 ) * ( DelXZ ** 2.0d0 ) )   

  call EndSub("TurbulenceVelX")
  
end subroutine TurbulenceVelX
